diff --git a/hw/xquartz/mach-startup/stub.c b/hw/xquartz/mach-startup/stub.c
index 83252e805..756e4ef2d 100644
--- a/hw/xquartz/mach-startup/stub.c
+++ b/hw/xquartz/mach-startup/stub.c
@@ -50,27 +50,45 @@
 
 #include <signal.h>
 
+#include <AvailabilityMacros.h>
+
 #include "launchd_fd.h"
 
-static CFURLRef x11appURL;
-static FSRef x11_appRef;
+static char x11_path[PATH_MAX + 1];
 static pid_t x11app_pid = 0;
 aslclient aslc;
 
 static void
 set_x11_path(void)
 {
-    OSStatus osstatus = LSFindApplicationForInfo(kLSUnknownCreator, CFSTR(kX11AppBundleId),
-                                                 nil, &x11_appRef, &x11appURL);
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
+
+    CFURLRef appURL = NULL;
+    OSStatus osstatus =
+        LSFindApplicationForInfo(kLSUnknownCreator, CFSTR(
+                                     kX11AppBundleId), nil, nil, &appURL);
 
     switch (osstatus) {
     case noErr:
-        if (x11appURL == NULL) {
+        if (appURL == NULL) {
+            asl_log(
+                aslc, NULL, ASL_LEVEL_ERR,
+                "Xquartz: Invalid response from LSFindApplicationForInfo(%s)",
+                kX11AppBundleId);
+            exit(1);
+        }
+
+        if (!CFURLGetFileSystemRepresentation(appURL, true,
+                                              (unsigned char *)x11_path,
+                                              sizeof(x11_path))) {
             asl_log(aslc, NULL, ASL_LEVEL_ERR,
-                    "Xquartz: Invalid response from LSFindApplicationForInfo(%s)",
+                    "Xquartz: Error resolving URL for %s",
                     kX11AppBundleId);
-            exit(1);
+            exit(3);
         }
+
+        strlcat(x11_path, kX11AppBundlePath, sizeof(x11_path));
+        asl_log(aslc, NULL, ASL_LEVEL_INFO, "Xquartz: X11.app = %s", x11_path);
         break;
 
     case kLSApplicationNotFoundErr:
@@ -82,9 +100,15 @@ set_x11_path(void)
     default:
         asl_log(aslc, NULL, ASL_LEVEL_ERR,
                 "Xquartz: Unable to find application for %s, error code = %d",
-                kX11AppBundleId, (int)osstatus);
+                kX11AppBundleId,
+                (int)osstatus);
         exit(11);
     }
+#else
+    /* TODO: Make Tiger smarter... but TBH, this should never get called on Tiger... */
+    strlcpy(x11_path, "/Applications/Utilities/X11.app/Contents/MacOS/X11",
+            sizeof(x11_path));
+#endif
 }
 
 static int
@@ -107,15 +131,18 @@ connect_to_socket(const char *filename)
     ret_fd = socket(PF_UNIX, SOCK_STREAM, 0);
     if (ret_fd == -1) {
         asl_log(aslc, NULL, ASL_LEVEL_ERR,
-                "Xquartz: Failed to create socket: %s - %d - %s",
-                filename, errno, strerror(errno));
+                "Xquartz: Failed to create socket: %s - %s", filename,
+                strerror(
+                    errno));
         return -1;
     }
 
     if (connect(ret_fd, servaddr, servaddr_len) < 0) {
         asl_log(aslc, NULL, ASL_LEVEL_ERR,
                 "Xquartz: Failed to connect to socket: %s - %d - %s",
-                filename, errno, strerror(errno));
+                filename, errno,
+                strerror(
+                    errno));
         close(ret_fd);
         return -1;
     }
@@ -158,9 +185,10 @@ send_fd_handoff(int connected_fd, int launchd_fd)
     *((int *)CMSG_DATA(cmsg)) = launchd_fd;
 
     if (sendmsg(connected_fd, &msg, 0) < 0) {
-        asl_log(aslc, NULL, ASL_LEVEL_ERR,
-                "Xquartz: Error sending $DISPLAY file descriptor over fd %d: %d -- %s",
-                connected_fd, errno, strerror(errno));
+        asl_log(
+            aslc, NULL, ASL_LEVEL_ERR,
+            "Xquartz: Error sending $DISPLAY file descriptor over fd %d: %d -- %s",
+            connected_fd, errno, strerror(errno));
         return;
     }
 
@@ -234,25 +262,26 @@ main(int argc, char **argv, char **envp)
                 server_bootstrap_name);
         set_x11_path();
 
-        char *listenOnlyArg = "--listenonly";
-        CFStringRef silentLaunchArg = CFStringCreateWithCString(NULL, listenOnlyArg, kCFStringEncodingUTF8);
-        CFStringRef args[] = { silentLaunchArg };
-        CFArrayRef passArgv = CFArrayCreate(NULL, (const void**) args, 1, NULL);
-        LSApplicationParameters params = { 0, /* CFIndex version == 0 */
-                                           kLSLaunchDefaults, /* LSLaunchFlags flags */
-                                           &x11_appRef, /* FSRef application */
-                                           NULL, /* void* asyncLaunchRefCon*/
-                                           NULL, /* CFDictionaryRef environment */
-                                           passArgv, /* CFArrayRef arguments */
-                                           NULL /* AppleEvent* initialEvent */
-        };
-
-        OSStatus status = LSOpenApplication(&params, NULL);
-        if (status != noErr) {
-            asl_log(aslc, NULL, ASL_LEVEL_ERR, "Xquartz: Unable to launch: %d", (int)status);
+        /* This forking is ugly and will be cleaned up later */
+        child = fork();
+        if (child == -1) {
+            asl_log(aslc, NULL, ASL_LEVEL_ERR, "Xquartz: Could not fork: %s",
+                    strerror(
+                        errno));
             return EXIT_FAILURE;
         }
 
+        if (child == 0) {
+            char *_argv[3];
+            _argv[0] = x11_path;
+            _argv[1] = "--listenonly";
+            _argv[2] = NULL;
+            asl_log(aslc, NULL, ASL_LEVEL_NOTICE,
+                    "Xquartz: Starting X server: %s --listenonly",
+                    x11_path);
+            return execvp(x11_path, _argv);
+        }
+
         /* Try connecting for 10 seconds */
         for (i = 0; i < 80; i++) {
             usleep(250000);
@@ -262,8 +291,15 @@ main(int argc, char **argv, char **envp)
         }
 
         if (kr != KERN_SUCCESS) {
+#if MAC_OS_X_VERSION_MIN_REQUIRED >= 1050
             asl_log(aslc, NULL, ASL_LEVEL_ERR,
-                    "Xquartz: bootstrap_look_up(): %s", bootstrap_strerror(kr));
+                    "Xquartz: bootstrap_look_up(): %s", bootstrap_strerror(
+                        kr));
+#else
+            asl_log(aslc, NULL, ASL_LEVEL_ERR,
+                    "Xquartz: bootstrap_look_up(): %ul",
+                    (unsigned long)kr);
+#endif
             return EXIT_FAILURE;
         }
     }
@@ -277,10 +313,13 @@ main(int argc, char **argv, char **envp)
         int handoff_fd = -1;
 
         for (try = 0, try_max = 5; try < try_max; try++) {
-            if (request_fd_handoff_socket(mp, handoff_socket_filename) != KERN_SUCCESS) {
-                asl_log(aslc, NULL, ASL_LEVEL_INFO,
-                        "Xquartz: Failed to request a socket from the server to send the $DISPLAY fd over (try %d of %d)",
-                        (int)try + 1, (int)try_max);
+            if (request_fd_handoff_socket(mp,
+                                          handoff_socket_filename) !=
+                KERN_SUCCESS) {
+                asl_log(
+                    aslc, NULL, ASL_LEVEL_INFO,
+                    "Xquartz: Failed to request a socket from the server to send the $DISPLAY fd over (try %d of %d)",
+                    (int)try + 1, (int)try_max);
                 continue;
             }
 
@@ -288,13 +327,16 @@ main(int argc, char **argv, char **envp)
             if (handoff_fd == -1) {
                 asl_log(aslc, NULL, ASL_LEVEL_ERR,
                         "Xquartz: Failed to connect to socket (try %d of %d)",
-                        (int)try + 1, (int)try_max);
+                        (int)try + 1,
+                        (int)try_max);
                 continue;
             }
 
-            asl_log(aslc, NULL, ASL_LEVEL_INFO,
-                    "Xquartz: Handoff connection established (try %d of %d) on fd %d, \"%s\".  Sending message.",
-                    (int)try + 1, (int)try_max, handoff_fd, handoff_socket_filename);
+            asl_log(
+                aslc, NULL, ASL_LEVEL_INFO,
+                "Xquartz: Handoff connection established (try %d of %d) on fd %d, \"%s\".  Sending message.",
+                (int)try + 1, (int)try_max, handoff_fd,
+                handoff_socket_filename);
             send_fd_handoff(handoff_fd, launchd_fd);
             close(handoff_fd);
             break;
@@ -315,7 +357,8 @@ main(int argc, char **argv, char **envp)
         free(newargv);
         free(newenvp);
 
-        asl_log(aslc, NULL, ASL_LEVEL_ERR, "Xquartz: Memory allocation failure");
+        asl_log(aslc, NULL, ASL_LEVEL_ERR,
+                "Xquartz: Memory allocation failure");
         return EXIT_FAILURE;
     }
 
@@ -333,7 +376,8 @@ main(int argc, char **argv, char **envp)
 
     if (kr != KERN_SUCCESS) {
         asl_log(aslc, NULL, ASL_LEVEL_ERR, "Xquartz: start_x11_server: %s",
-                mach_error_string(kr));
+                mach_error_string(
+                    kr));
         return EXIT_FAILURE;
     }
     return EXIT_SUCCESS;
diff --git a/hw/xquartz/man/Xquartz.man b/hw/xquartz/man/Xquartz.man
index 643bea9df..056086884 100644
--- a/hw/xquartz/man/Xquartz.man
+++ b/hw/xquartz/man/Xquartz.man
@@ -84,7 +84,7 @@ This option defaults to false and is provided only "for experts."  It updates th
 .B defaults write @bundle_id_prefix@.X11 enable_test_extensions -boolean true
 This option defaults to false and is only accessible through the command line.  Enable this option to turn on the DEC-XTRAP, RECORD, and XTEST extensions in the server.
 .TP 8
-.B defaults write @bundle_id_prefix@.X11 scroll_in_device_direction -boolean true
+.B defaults write @laucnd_id_prefix@.X11 scroll_in_device_direction -boolean true
 This option defaults to false.  Enable this option to ensure that X11 scroll events are always in the direction of the device.  This overrides the related option in the Mouse/Trackpad section of System Preferences.
 .SH OPTIONS
 .PP
diff --git a/hw/xquartz/pbproxy/app-main.m b/hw/xquartz/pbproxy/app-main.m
index 825980caf..eda9a9e67 100644
--- a/hw/xquartz/pbproxy/app-main.m
+++ b/hw/xquartz/pbproxy/app-main.m
@@ -31,6 +31,13 @@
 #include "pbproxy.h"
 #import "x-selection.h"
 
+#include <pthread.h>
+#include <unistd.h> /*for getpid*/
+#include <Cocoa/Cocoa.h>
+
+static const char *app_prefs_domain = BUNDLE_ID_PREFIX ".xpbproxy";
+CFStringRef app_prefs_domain_cfstr;
+
 /* Stubs */
 char *display = NULL;
 
@@ -75,8 +82,41 @@
 int
 main(int argc, const char *argv[])
 {
+    const char *s;
+    int i;
+
+#ifdef DEBUG
+    ErrorF("pid: %u\n", getpid());
+#endif
+
     xpbproxy_is_standalone = YES;
 
+    if ((s = getenv("X11_PREFS_DOMAIN")))
+        app_prefs_domain = s;
+
+    for (i = 1; i < argc; i++) {
+        if (strcmp(argv[i], "--prefs-domain") == 0 && i + 1 < argc) {
+            app_prefs_domain = argv[++i];
+        }
+        else if (strcmp(argv[i], "--help") == 0) {
+            ErrorF(
+                "usage: xpbproxy OPTIONS\n"
+                "Pasteboard proxying for X11.\n\n"
+                "--prefs-domain <domain>   Change the domain used for reading preferences\n"
+                "                          (default: %s)\n",
+                app_prefs_domain);
+            return 0;
+        }
+        else {
+            ErrorF("usage: xpbproxy OPTIONS...\n"
+                   "Try 'xpbproxy --help' for more information.\n");
+            return 1;
+        }
+    }
+
+    app_prefs_domain_cfstr = CFStringCreateWithCString(NULL, app_prefs_domain,
+                                                       kCFStringEncodingUTF8);
+
     signal(SIGINT, signal_handler);
     signal(SIGTERM, signal_handler);
     signal(SIGHUP, signal_handler);
diff --git a/hw/xquartz/pbproxy/main.m b/hw/xquartz/pbproxy/main.m
index 92cde0437..2d2f76108 100644
--- a/hw/xquartz/pbproxy/main.m
+++ b/hw/xquartz/pbproxy/main.m
@@ -78,49 +78,55 @@
 int
 xpbproxy_run(void)
 {
-    @autoreleasepool {
-        size_t i;
+    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    size_t i;
 
-        for (i = 0, xpbproxy_dpy = NULL; !xpbproxy_dpy && i < 5; i++) {
-            xpbproxy_dpy = XOpenDisplay(NULL);
+    for (i = 0, xpbproxy_dpy = NULL; !xpbproxy_dpy && i < 5; i++) {
+        xpbproxy_dpy = XOpenDisplay(NULL);
 
-            if (!xpbproxy_dpy && display) {
-                char _display[32];
-                snprintf(_display, sizeof(_display), ":%s", display);
-                setenv("DISPLAY", _display, TRUE);
+        if (!xpbproxy_dpy && display) {
+            char _display[32];
+            snprintf(_display, sizeof(_display), ":%s", display);
+            setenv("DISPLAY", _display, TRUE);
 
-                xpbproxy_dpy = XOpenDisplay(_display);
-            }
-            if (!xpbproxy_dpy)
-                sleep(1);
+            xpbproxy_dpy = XOpenDisplay(_display);
         }
+        if (!xpbproxy_dpy)
+            sleep(1);
+    }
 
-        if (xpbproxy_dpy == NULL) {
-            ErrorF("xpbproxy: can't open default display\n");
-            return EXIT_FAILURE;
-        }
+    if (xpbproxy_dpy == NULL) {
+        ErrorF("xpbproxy: can't open default display\n");
+        [pool release];
+        return EXIT_FAILURE;
+    }
 
-        XSetIOErrorHandler(x_io_error_handler);
-        XSetErrorHandler(x_error_handler);
+    XSetIOErrorHandler(x_io_error_handler);
+    XSetErrorHandler(x_error_handler);
 
-        if (!XAppleWMQueryExtension(xpbproxy_dpy, &xpbproxy_apple_wm_event_base,
-                                    &xpbproxy_apple_wm_error_base)) {
-            ErrorF("xpbproxy: can't open AppleWM server extension\n");
-            return EXIT_FAILURE;
-        }
+    if (!XAppleWMQueryExtension(xpbproxy_dpy, &xpbproxy_apple_wm_event_base,
+                                &xpbproxy_apple_wm_error_base)) {
+        ErrorF("xpbproxy: can't open AppleWM server extension\n");
+        [pool release];
+        return EXIT_FAILURE;
+    }
 
-        xpbproxy_have_xfixes = XFixesQueryExtension(xpbproxy_dpy, &xpbproxy_xfixes_event_base,
-                                                    &xpbproxy_xfixes_error_base);
+    xpbproxy_have_xfixes =
+        XFixesQueryExtension(xpbproxy_dpy, &xpbproxy_xfixes_event_base,
+                             &xpbproxy_xfixes_error_base);
 
-        XAppleWMSelectInput(xpbproxy_dpy, AppleWMActivationNotifyMask | AppleWMPasteboardNotifyMask);
+    XAppleWMSelectInput(xpbproxy_dpy, AppleWMActivationNotifyMask |
+                        AppleWMPasteboardNotifyMask);
 
-        _selection_object = [x_selection new];
+    _selection_object = [[x_selection alloc] init];
 
-        if (!xpbproxy_input_register()) {
-            return EXIT_FAILURE;
-        }
+    if (!xpbproxy_input_register()) {
+        [pool release];
+        return EXIT_FAILURE;
     }
 
+    [pool release];
+
     CFRunLoopRun();
 
     return EXIT_SUCCESS;
diff --git a/hw/xquartz/pbproxy/pbproxy.h b/hw/xquartz/pbproxy/pbproxy.h
index 482f95ea6..c5a07f2d0 100644
--- a/hw/xquartz/pbproxy/pbproxy.h
+++ b/hw/xquartz/pbproxy/pbproxy.h
@@ -35,6 +35,17 @@
 
 #include <asl.h>
 
+#include <AvailabilityMacros.h>
+#if MAC_OS_X_VERSION_MIN_REQUIRED < 1050
+#if __LP64__ || NS_BUILD_32_LIKE_64
+typedef long NSInteger;
+typedef unsigned long NSUInteger;
+#else
+typedef int NSInteger;
+typedef unsigned int NSUInteger;
+#endif
+#endif
+
 #define  Cursor X_Cursor
 #undef _SHAPE_H_
 #include <X11/Xlib.h>
diff --git a/hw/xquartz/pbproxy/x-input.m b/hw/xquartz/pbproxy/x-input.m
index 3be9ce407..71b46a8b3 100644
--- a/hw/xquartz/pbproxy/x-input.m
+++ b/hw/xquartz/pbproxy/x-input.m
@@ -89,7 +89,14 @@
 static void
 xpbproxy_process_xevents(void)
 {
-    while (XPending(xpbproxy_dpy) != 0) { @autoreleasepool {
+    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+
+    if (pool == nil) {
+        ErrorF("unable to allocate/init auto release pool!\n");
+        return;
+    }
+
+    while (XPending(xpbproxy_dpy) != 0) {
         XEvent e;
 
         XNextEvent(xpbproxy_dpy, &e);
@@ -127,7 +134,9 @@
         }
 
         XFlush(xpbproxy_dpy);
-    }}
+    }
+
+    [pool release];
 }
 
 static BOOL
diff --git a/hw/xquartz/pbproxy/x-selection.m b/hw/xquartz/pbproxy/x-selection.m
index f4f2b9a6b..b89a5760e 100644
--- a/hw/xquartz/pbproxy/x-selection.m
+++ b/hw/xquartz/pbproxy/x-selection.m
@@ -38,8 +38,6 @@
 #import <AppKit/NSImage.h>
 #import <AppKit/NSBitmapImageRep.h>
 
-#import "NSUserDefaults+XQuartzDefaults.h"
-
 /*
  * The basic design of the pbproxy code is as follows.
  *
@@ -101,6 +99,18 @@ @implementation x_selection
 }
 #endif
 
+extern CFStringRef app_prefs_domain_cfstr;
+
+static BOOL
+prefs_get_bool(CFStringRef key, BOOL defaultValue)
+{
+    Boolean value, ok;
+
+    value = CFPreferencesGetAppBooleanValue(key, app_prefs_domain_cfstr, &ok);
+
+    return ok ? (BOOL)value : defaultValue;
+}
+
 static void
 init_propdata(struct propdata *pdata)
 {
@@ -663,8 +673,13 @@ - (void) send_string:(XSelectionRequestEvent *)e utf8:(BOOL)utf8 pasteboard:(
         return;
     }
 
+#ifdef __LP64__
     DebugF("pbtypes retainCount after containsObject: %lu\n",
            [pbtypes retainCount]);
+#else
+    DebugF("pbtypes retainCount after containsObject: %u\n",
+           [pbtypes retainCount]);
+#endif
 
     data = [pb stringForType:NSStringPboardType];
 
@@ -683,7 +698,11 @@ - (void) send_string:(XSelectionRequestEvent *)e utf8:(BOOL)utf8 pasteboard:(
 
         if (length < 50) {
             DebugF("UTF-8: %s\n", bytes);
+#ifdef __LP64__
             DebugF("UTF-8 length: %lu\n", length);
+#else
+            DebugF("UTF-8 length: %u\n", length);
+#endif
         }
     }
     else {
@@ -1177,8 +1196,13 @@ - (void) handle_image: (struct propdata *)pdata pasteboard:(NSPasteboard *)pb
         return;
     }
 
+#ifdef __LP64__
     DebugF("data retainCount before NSBitmapImageRep initWithData: %lu\n",
            [data retainCount]);
+#else
+    DebugF("data retainCount before NSBitmapImageRep initWithData: %u\n",
+           [data retainCount]);
+#endif
 
     bmimage = [[NSBitmapImageRep alloc] initWithData:data];
 
@@ -1188,8 +1212,13 @@ - (void) handle_image: (struct propdata *)pdata pasteboard:(NSPasteboard *)pb
         return;
     }
 
+#ifdef __LP64__
     DebugF("data retainCount after NSBitmapImageRep initWithData: %lu\n",
            [data retainCount]);
+#else
+    DebugF("data retainCount after NSBitmapImageRep initWithData: %u\n",
+           [data retainCount]);
+#endif
 
     @try
     {
@@ -1204,8 +1233,13 @@ - (void) handle_image: (struct propdata *)pdata pasteboard:(NSPasteboard *)pb
         return;
     }
 
+#ifdef __LP64__
     DebugF("bmimage retainCount after TIFFRepresentation %lu\n",
            [bmimage retainCount]);
+#else
+    DebugF("bmimage retainCount after TIFFRepresentation %u\n",
+           [bmimage retainCount]);
+#endif
 
     pbtypes = [NSArray arrayWithObjects:NSTIFFPboardType, nil];
 
@@ -1222,7 +1256,11 @@ - (void) handle_image: (struct propdata *)pdata pasteboard:(NSPasteboard *)pb
 
     [data autorelease];
 
+#ifdef __LP64__
     DebugF("bmimage retainCount before release %lu\n", [bmimage retainCount]);
+#else
+    DebugF("bmimage retainCount before release %u\n", [bmimage retainCount]);
+#endif
 
     [bmimage autorelease];
 }
@@ -1384,18 +1422,35 @@ - (void) copy_completed:(Atom)selection
 
 - (void) reload_preferences
 {
-    NSUserDefaults * const defaults = NSUserDefaults.xquartzDefaults;
-
+    /*
+     * It's uncertain how we could handle the synchronization failing, so cast to void.
+     * The prefs_get_bool should fall back to defaults if the org.x.X11 plist doesn't exist or is invalid.
+     */
+    (void)CFPreferencesAppSynchronize(app_prefs_domain_cfstr);
 #ifdef STANDALONE_XPBPROXY
     if (xpbproxy_is_standalone)
         pbproxy_prefs.active = YES;
     else
 #endif
-    pbproxy_prefs.active = [defaults boolForKey:XQuartzPrefKeySyncPasteboard];
-    pbproxy_prefs.primary_on_grab = [defaults boolForKey:XQuartzPrefKeySyncPrimaryOnSelect];
-    pbproxy_prefs.clipboard_to_pasteboard = [defaults boolForKey:XQuartzPrefKeySyncClipboardToPasteBoard];
-    pbproxy_prefs.pasteboard_to_primary = [defaults boolForKey:XQuartzPrefKeySyncPasteboardToPrimary];
-    pbproxy_prefs.pasteboard_to_clipboard = [defaults boolForKey:XQuartzPrefKeySyncPasteboardToClipboard];
+    pbproxy_prefs.active = prefs_get_bool(CFSTR(
+                                              "sync_pasteboard"),
+                                          pbproxy_prefs.active);
+    pbproxy_prefs.primary_on_grab =
+        prefs_get_bool(CFSTR(
+                           "sync_primary_on_select"),
+                       pbproxy_prefs.primary_on_grab);
+    pbproxy_prefs.clipboard_to_pasteboard =
+        prefs_get_bool(CFSTR(
+                           "sync_clipboard_to_pasteboard"),
+                       pbproxy_prefs.clipboard_to_pasteboard);
+    pbproxy_prefs.pasteboard_to_primary =
+        prefs_get_bool(CFSTR(
+                           "sync_pasteboard_to_primary"),
+                       pbproxy_prefs.pasteboard_to_primary);
+    pbproxy_prefs.pasteboard_to_clipboard =
+        prefs_get_bool(CFSTR(
+                           "sync_pasteboard_to_clipboard"),
+                       pbproxy_prefs.pasteboard_to_clipboard);
 
     /* This is used for debugging. */
     //dump_prefs();
diff --git a/hw/xquartz/quartz.c b/hw/xquartz/quartz.c
index 4bbe56b93..b0dfcbe68 100644
--- a/hw/xquartz/quartz.c
+++ b/hw/xquartz/quartz.c
@@ -35,6 +35,7 @@
 #include <dix-config.h>
 #endif
 
+#include "quartzCommon.h"
 #include "quartzRandR.h"
 #include "inputstr.h"
 #include "quartz.h"
@@ -71,30 +72,25 @@
 #include <rootlessCommon.h>
 #include <Xplugin.h>
 
-// These are vended by the Objective-C runtime, but they are unfortunately
-// not available as API in the macOS SDK.  We are following suit with swift
-// and clang in declaring them inline here.  They canot be removed or changed
-// in the OS without major bincompat ramifications.
-//
-// These were added in macOS 10.7.
-void * _Nonnull objc_autoreleasePoolPush(void);
-void objc_autoreleasePoolPop(void * _Nonnull context);
+/* Work around a bug on Leopard's headers */
+#if defined (__LP64__) && MAC_OS_X_VERSION_MAX_ALLOWED >= 1050 && MAC_OS_X_VERSION_MAX_ALLOWED < 1060
+extern OSErr UpdateSystemActivity(UInt8 activity);
+#define OverallAct 0
+#endif
 
 DevPrivateKeyRec quartzScreenKeyRec;
 int aquaMenuBarHeight = 0;
 QuartzModeProcsPtr quartzProcs = NULL;
 const char             *quartzOpenGLBundle = NULL;
 
-/* These are initialized by X11Application with default values set in NSUserDefaults+XQuartzDefaults */
-Bool XQuartzFullscreenDisableHotkeys;
-Bool XQuartzOptionSendsAlt;
-Bool XQuartzEnableKeyEquivalents;
-Bool XQuartzFullscreenMenu;
-Bool XQuartzRootlessDefault;
-
+Bool XQuartzFullscreenDisableHotkeys = TRUE;
+Bool XQuartzOptionSendsAlt = FALSE;
+Bool XQuartzEnableKeyEquivalents = TRUE;
 Bool XQuartzFullscreenVisible = FALSE;
+Bool XQuartzRootlessDefault = TRUE;
 Bool XQuartzIsRootless = TRUE;
 Bool XQuartzServerVisible = FALSE;
+Bool XQuartzFullscreenMenu = FALSE;
 
 int32_t XQuartzShieldingWindowLevel = 0;
 
@@ -153,30 +149,6 @@ QuartzSetupScreen(int index,
     return TRUE;
 }
 
-/*
- * QuartzBlockHandler
- *  Clean out any autoreleased objects.
- */
-static void
-QuartzBlockHandler(void *blockData, void *pTimeout)
-{
-    static void *poolToken = NULL;
-
-    if (poolToken) {
-        objc_autoreleasePoolPop(poolToken);
-    }
-    poolToken = objc_autoreleasePoolPush();
-}
-
-/*
- * QuartzWakeupHandler
- */
-static void
-QuartzWakeupHandler(void *blockData, int result)
-{
-    /* nothing here */
-}
-
 /*
  * QuartzInitOutput
  *  Quartz display initialization.
@@ -308,8 +280,8 @@ QuartzUpdateScreens(void)
 
     quartzProcs->UpdateScreen(pScreen);
 
-    /* PaintWindow needs to be called after RootlessUpdateScreenPixmap (from xprUpdateScreen) */
-    pScreen->PaintWindow(pRoot, &pRoot->borderClip, PW_BACKGROUND);
+    /* miPaintWindow needs to be called after RootlessUpdateScreenPixmap (from xprUpdateScreen) */
+    miPaintWindow(pRoot, &pRoot->borderClip, PW_BACKGROUND);
 
     /* Tell RandR about the new size, so new connections get the correct info */
     RRScreenSizeNotify(pScreen);
diff --git a/hw/xquartz/quartz.h b/hw/xquartz/quartz.h
index 3a456f573..ddbf2e780 100644
--- a/hw/xquartz/quartz.h
+++ b/hw/xquartz/quartz.h
@@ -34,9 +34,6 @@
 #ifndef _QUARTZ_H
 #define _QUARTZ_H
 
-#include <X11/Xdefs.h>
-#include "privates.h"
-
 #include "screenint.h"
 #include "window.h"
 #include "pixmap.h"
@@ -130,14 +127,6 @@ extern Bool XQuartzOptionSendsAlt;   /* Alt or Mode_switch? */
 
 extern int32_t XQuartzShieldingWindowLevel; /* CGShieldingWindowLevel() or 0 */
 
-// Other shared data
-extern DevPrivateKeyRec quartzScreenKeyRec;
-#define quartzScreenKey (&quartzScreenKeyRec)
-extern int aquaMenuBarHeight;
-
-// Name of GLX bundle for native OpenGL
-extern const char      *quartzOpenGLBundle;
-
 Bool
 QuartzAddScreen(int index, ScreenPtr pScreen);
 Bool
diff --git a/hw/xquartz/quartzCocoa.m b/hw/xquartz/quartzCocoa.m
new file mode 100644
index 000000000..ac6f67e2b
--- /dev/null
+++ b/hw/xquartz/quartzCocoa.m
@@ -0,0 +1,66 @@
+/**************************************************************
+ *
+ * Quartz-specific support for the Darwin X Server
+ * that requires Cocoa and Objective-C.
+ *
+ * This file is separate from the parts of Quartz support
+ * that use X include files to avoid symbol collisions.
+ *
+ * Copyright (c) 2001-2004 Torrey T. Lyons and Greg Parker.
+ *                 All Rights Reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Except as contained in this notice, the name(s) of the above copyright
+ * holders shall not be used in advertising or otherwise to promote the sale,
+ * use or other dealings in this Software without prior written authorization.
+ */
+
+#include "sanitizedCocoa.h"
+
+#ifdef HAVE_DIX_CONFIG_H
+#include <dix-config.h>
+#endif
+
+#include "quartzCommon.h"
+#include "inputstr.h"
+
+#include "darwin.h"
+
+/*
+ * QuartzBlockHandler
+ *  Clean out any autoreleased objects.
+ */
+void
+QuartzBlockHandler(void *blockData, void *pTimeout)
+{
+    static NSAutoreleasePool *aPool = nil;
+
+    [aPool release];
+    aPool = [[NSAutoreleasePool alloc] init];
+}
+
+/*
+ * QuartzWakeupHandler
+ */
+void
+QuartzWakeupHandler(void *blockData, int result)
+{
+    // nothing here
+}
diff --git a/hw/xquartz/quartzCommon.h b/hw/xquartz/quartzCommon.h
new file mode 100644
index 000000000..721886b87
--- /dev/null
+++ b/hw/xquartz/quartzCommon.h
@@ -0,0 +1,55 @@
+/*
+ * quartzCommon.h
+ *
+ * Common definitions used internally by all Quartz modes
+ *
+ * This file should be included before any X11 or IOKit headers
+ * so that it can avoid symbol conflicts.
+ *
+ * Copyright (c) 2001-2004 Torrey T. Lyons and Greg Parker.
+ *                 All Rights Reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
+ * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
+ * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
+ * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ * DEALINGS IN THE SOFTWARE.
+ *
+ * Except as contained in this notice, the name(s) of the above copyright
+ * holders shall not be used in advertising or otherwise to promote the sale,
+ * use or other dealings in this Software without prior written authorization.
+ */
+
+#ifndef _QUARTZCOMMON_H
+#define _QUARTZCOMMON_H
+
+#include <X11/Xdefs.h>
+#include "privates.h"
+
+// Other shared data
+extern DevPrivateKeyRec quartzScreenKeyRec;
+#define quartzScreenKey (&quartzScreenKeyRec)
+extern int aquaMenuBarHeight;
+
+// Name of GLX bundle for native OpenGL
+extern const char      *quartzOpenGLBundle;
+
+void
+QuartzBlockHandler(void *blockData, void *pTimeout);
+
+void
+QuartzWakeupHandler(void *blockData, int result);
+
+#endif  /* _QUARTZCOMMON_H */
